//
// Interrupts
//
//20 ns = 50 MHz
`define CLOCK_PERIOD 20

//Reset type
`define POSITIVE_RESET
//`define NEGATIVE_RESET

//Tap out signals
//`define SIGNAL_TAP


`define INTR_LIGHT

//
// TAP selection
//
`define FPGA_TAP



//
// Memory type	(uncomment something if ASIC or generic memory)
//
//`define GENERIC_MEMORY
//`define AVANT_ATP
//`define VIRAGE_SSP
//`define VIRTUALSILICON_SSP

//Included modules
`define UART0
`define RAM_WB

/*
MEMORY_ADR_WIDTH IS NOT ALLOWED TO BE LESS THAN 12, 
memory is composed by blocks of address width 11
Address width of memory -> select memory depth, 
2 powers MEMORY_ADR_WIDTH defines the memory depth 
the memory data width is 32 bit, 
memory amount in Bytes = 4*memory depth
*/

//RAM parameters
`define MEM_SIZE_BYTES		(8192*1024)//8388608 bytes = 8MB, 0x0080_0000
`define	MEM_ADDR_WIDTH		16
`define MEM_START_ADDR		0

//UART parameters
`define UART_START_ADDR		90
`define UART_INTERRUPT		2

//Intgen
`define INTGEN0_ADDR			a0
`define INTGEN1_ADDR			a1

//
// Address map
//
`define 	ARB_ADDR_WIDTH		8
`define	ARB_NUM_SLAVES		4
`define	SLAVE0_ADDR			4'h`MEM_START_ADDR //RAM
`define 	SLAVE1_ADDR			`ARB_ADDR_WIDTH'h`UART_START_ADDR //UART
`define	SLAVE2_ADDR			`ARB_ADDR_WIDTH'h`INTGEN0_ADDR
`define 	SLAVE3_ADDR			`ARB_ADDR_WIDTH'h`INTGEN1_ADDR
`define 	SLAVE4_ADDR			`ARB_ADDR_WIDTH'h30
`define 	SLAVE5_ADDR			`ARB_ADDR_WIDTH'h40
`define 	SLAVE6_ADDR			`ARB_ADDR_WIDTH'h50
`define 	SLAVE7_ADDR			`ARB_ADDR_WIDTH'h60
`define 	SLAVE8_ADDR			`ARB_ADDR_WIDTH'h70


//
// Arbiter defines
//

// Uncomment to register things through arbiter (hopefully quicker design)
// Instruction bus arbiter
//`define ARBITER_IBUS_REGISTERING
`define ARBITER_IBUS_WATCHDOG
// Watchdog timeout: 2^(ARBITER_IBUS_WATCHDOG_TIMER_WIDTH+1) cycles
`define ARBITER_IBUS_WATCHDOG_TIMER_WIDTH 12

// Data bus arbiter

//`define ARBITER_DBUS_REGISTERING
`define ARBITER_DBUS_WATCHDOG
// Watchdog timeout: 2^(ARBITER_DBUS_WATCHDOG_TIMER_WIDTH+1) cycles
`define ARBITER_DBUS_WATCHDOG_TIMER_WIDTH 12

// Byte bus (peripheral bus) arbiter
// Don't really need the watchdog here - the databus will pick it up
//`define ARBITER_BYTEBUS_WATCHDOG
// Watchdog timeout: 2^(ARBITER_BYTEBUS_WATCHDOG_TIMER_WIDTH+1) cycles
`define ARBITER_BYTEBUS_WATCHDOG_TIMER_WIDTH 9

//
// Define FPGA manufacturer
//
//`define GENERIC_FPGA
`define ALTERA_FPGA
//`define XILINX_FPGA

// 
// Define Xilinx FPGA family
//
`ifdef XILINX_FPGA
//`define SPARTAN2
//`define SPARTAN3
//`define SPARTAN3E
//`define SPARTAN3A
//`define VIRTEX
//`define VIRTEX2
//`define VIRTEX4
//`define VIRTEX5

//
// Define Altera FPGA family
//
`elsif ALTERA_FPGA
//`define ARRIA_GX
//`define ARRIA_II_GX
//`define CYCLONE_I
//`define CYCLONE_II
//`define CYCLONE_III
//`define CYCLONE_III_LS
//`define CYCLONE_IV_E
//`define CYCLONE_IV_GS
//`define MAX_II
//`define MAX_V
//`define MAX3000A
//`define MAX7000AE
//`define MAX7000B
//`define MAX7000S
//`define STRATIX
//`define STRATIX_II
//`define STRATIX_II_GX
//`define STRATIX_III
`endif


//`define DEBUG
