/*
 * tmu.h
 *
 *  Created on: May 15, 2014
 *      Author: kyrre
 */
#ifndef TMU_H_
#define TMU_H_

typedef unsigned long ulong;
typedef unsigned long long udlong;

/*
 * TMU CONTROL FUNCTIONS
 */
void tmu_start();
void tmu_stop();
void tmu_restart();
void tmu_clear();
void tmu_enable_exception();
void tmu_disable_exception();
void tmu_enable_count_exception();
void tmu_disable_count_exception();
void tmu_enable_count_freeze();
void tmu_disable_count_freeze();
void tmu_enable_count_interrupt();
void tmu_disable_count_interrupt();

/*
 * TMU TASK R/W FUNCTIONS
 */
void tmu_set_control(ulong val);
ulong tmu_get_status();
void tmu_set_compare(udlong val);
void tmu_set_count(udlong val);
udlong tmu_get_compare();
udlong tmu_get_count();

/*
 * TMU INTERRUPT R/W FUNCTIONS
 */
void tmu_set_interrupt_rep_period(udlong val);
udlong tmu_get_interrupt_rep_period();
void tmu_set_interrupt_compare(int line, ulong val);
ulong tmu_get_interrupt_compare(int line);
void tmu_rst_interrupt_count(int line);
ulong tmu_get_interrupt_count(int line);

#endif /* TMU_H_ */
