/*
 * tmu.c
 *
 *  Created on: May 15, 2014
 *      Author: kyrre
 */
#include "tmu.h"
#include "spr-defs.h"
//#include "support.h"
/*
 * TMU CONTROL FUNCTIONS
 */
void tmu_start()
{
	tmu_set_control(SPR_TMU_CTRL_START);
}

void tmu_stop()
{
	tmu_set_control(SPR_TMU_CTRL_STOP);
}

void tmu_restart()
{
	tmu_set_control(SPR_TMU_CTRL_RESTART);
}

void tmu_clear()
{
	tmu_set_control(SPR_TMU_CTRL_CLEAR);
}

void tmu_enable_exception()
{
	tmu_set_control(SPR_TMU_CTRL_EE);
}

void tmu_disable_exception()
{
	tmu_set_control(SPR_TMU_CTRL_ED);
}

void tmu_enable_count_exception()
{
	tmu_set_control(SPR_TMU_CTRL_CEE);
}
void tmu_disable_count_exception()
{
	tmu_set_control(SPR_TMU_CTRL_CED);
}

void tmu_enable_count_freeze()
{
	tmu_set_control(SPR_TMU_CTRL_FCE);
}

void tmu_disable_count_freeze()
{
	tmu_set_control(SPR_TMU_CTRL_FCD);
}
void tmu_enable_count_interrupt()
{
	tmu_set_control(SPR_TMU_CTRL_CIE);
}
void tmu_disable_count_interrupt()
{
	tmu_set_control(SPR_TMU_CTRL_CID);
}

/*
void tmu_enable_()
{
	tmu_set_control(SPR_TMU_CTRL_);
}

void tmu_disable_()
{
	tmu_set_control(SPR_TMU_CTRL_);
}
*/

/*
 * TMU TASK R/W FUNCTIONS
 */
void tmu_set_control(ulong val)
{
	mtspr(SPR_TMU_CTRL, val);
}
ulong tmu_get_status()
{
	return (mfspr(SPR_TMU_STATUS));
}

void tmu_set_compare(udlong val)
{
	tmu_stop();
	ulong low, high;
	low = val & 0x00000000FFFFFFFF;
	high = val >> 32;
	mtspr(SPR_TMU_CMP_H, high);
	mtspr(SPR_TMU_CMP_L, low);
}

void tmu_set_count(udlong val)
{
	tmu_stop();
	ulong low, high;
	low = val & 0x00000000FFFFFFFF;
	high = val >> 32;
	mtspr(SPR_TMU_CNT_H, high);
	mtspr(SPR_TMU_CNT_L, low);
}

udlong tmu_get_compare()
{
	ulong low, high;
	udlong ret;
	low = mfspr(SPR_TMU_CMP_L);
	high= mfspr(SPR_TMU_CMP_H);
	ret = (udlong) high << 32 | low;

	return ret; //((udlong) mfspr(SPR_TMU_CMP_H) << 32 | mfspr(SPR_TMU_CMP_L));
}
udlong tmu_get_count()
{
	return ((udlong) mfspr(SPR_TMU_CNT_H) << 32 | mfspr(SPR_TMU_CNT_L));
}

/*
 * TMU INTERRUPT R/W FUNCTIONS
 */
void tmu_set_interrupt_rep_period(udlong val)
{
	ulong low, high;
	low = val & 0x00000000FFFFFFFF;
	high = val >> 32;
	mtspr(SPR_TMU_REPCMP_H, high);
	mtspr(SPR_TMU_REPCMP_L, low);
}

udlong tmu_get_interrupt_rep_period()
{
	return ((udlong) mfspr(SPR_TMU_REPCMP_H) << 32 | mfspr(SPR_TMU_REPCMP_L));
}
void tmu_set_interrupt_compare(int line, ulong val)
{
	mtspr(SPR_TMU_INTRCMP_BASE+line, val);
}
ulong tmu_get_interrupt_compare(int line)
{
	return (mfspr(SPR_TMU_INTRCMP_BASE+line));
}
void tmu_rst_interrupt_count(int line)
{
	mtspr(SPR_TMU_INTRCNT_BASE+line, 0);
}

ulong tmu_get_interrupt_count(int line)
{
	return (mfspr(SPR_TMU_INTRCNT_BASE+line));
}














