
#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"
#include "uart.h"
#include "intgen.h"
#include "inttest.h"

#define INT0_VECT 0x03
#define INT1_VECT 0x04

void inttest_main()
{
  	vSemaphoreCreateBinary(xSemaphore);

	if( xSemaphore == NULL )
	{
		uart_print_str("Main:: Failed to initiate semaphore \n ");
	}

	int_add(INT0_VECT, int0_handle, NULL);
	int_add(INT1_VECT, int1_handle, NULL);
	
	xTaskCreateException(&Task1, NULL);
	xTaskCreateException(&Task2, NULL);
	xSemaphoreGive(xSemaphore);
}

xTMUStruct task1TMU =
{
	task1_exception,
	0,	 		// Count High
	0, 			// Count Low
	10,			// Compare High
	0,			// Compare Low
	0x10005501 	// Control
};

xTMUStruct task2TMU =
{
	task2_exception,
	0,	 		// Count High
	0, 			// Count Low
	0, 			// Compare High
	10000000,	// Compare Low
	0x20005501 	// Control
};

const xTaskParameters Task1 =
{
	(task1_func),		// pvTaskCode - the function that implements the task.
	("Task1"),	// pcName - just a text name for the task to assist debugging.
	(configMINIMAL_STACK_SIZE),		// usStackDepth	- the stack size DEFINED IN WORDS.
	(NULL),		// pvParameters - passed into the task function as the function parameters.
	(dualtaskDELAY_PRIORITY+1),// uxPriority - task priority, set the portPRIVILEGE_BIT if the task should run in a privileged state.
	(NULL),// puxStackBuffer - the buffer to be used as the task stack.

	// xRegions - Allocate up to three separate memory regions for access by
	// the task, with appropriate access permissions.  Different processors have
	// different memory alignment requirements - refer to the FreeRTOS documentation
	// for full information.
	{NULL},
	&task1TMU
};

const xTaskParameters Task2 =
{
	(task2_func),		// pvTaskCode - the function that implements the task.
	("Task2"),	// pcName - just a text name for the task to assist debugging.
	(configMINIMAL_STACK_SIZE),		// usStackDepth	- the stack size DEFINED IN WORDS.
	(NULL),		// pvParameters - passed into the task function as the function parameters.
	(dualtaskDELAY_PRIORITY+1),// uxPriority - task priority, set the portPRIVILEGE_BIT if the task should run in a privileged state.
	(NULL),// puxStackBuffer - the buffer to be used as the task stack.

	// xRegions - Allocate up to three separate memory regions for access by
	// the task, with appropriate access permissions.  Different processors have
	// different memory alignment requirements - refer to the FreeRTOS documentation
	// for full information.
	{NULL},
	&task2TMU
};



void task1_func(void * param)
{
	uart_print_str("task1Func:: Started \n");
	param=param;
	portTickType xLastWakeTime;
	const portTickType xFrequency = 1000;
	xLastWakeTime = xTaskGetTickCount();

	int i,j=3,k=2,t=1;
	while(1){
/*		//vTaskDelayUntil( &xLastWakeTime, xFrequency );
		if (xSemaphoreTake(xSemaphore,(portTickType)1) == pdTRUE)
		{
			//got semaphore
			uart_print_str("task1Func::Alive\n");

					for (i = 0; i < 10; i++)
					{
						t=j;;
						j=k;
						k=t;
					}

			xSemaphoreGive(xSemaphore);
			vTaskDelay(1);
		}
		else
		{
			//did not get semaphore
		}
	}
*/
	}
}


void task1_exception(void * param)
{
	uart_print_str("Exception:: Task1 \n");
	//handle1
}

void task2_func(void* param)
{

	uart_print_str("task2Func:: Started \n");
	param=param;
	portTickType xLastWakeTime;
	const portTickType xFrequency = 1000;
	xLastWakeTime = xTaskGetTickCount();
	int i,j=3,k=2,t=1;
	char buf[50];
	while(1){
/*		//vTaskDelayUntil( &xLastWakeTime, xFrequency );
		if ( xSemaphoreTake(xSemaphore, (portTickType) 1) == pdTRUE)
		{
			//got semaphore

			uart_print_str("task2Func::Alive\n");

			for (i = 0; i < 10; i++)
			{
				t=j;;
				j=k;
				k=t;
			}

			xSemaphoreGive(xSemaphore);
			vTaskDelay(1);
		}
		else
		{
			//did not get semaphore
		}
	}
	*/
	}

}

void task2_exception(void * param)
{
	uart_print_str("Exception:: Task2 \n");
	//handle2
}

void *int0_handle(void) {


	;;

}


void *int1_handle(void) {


	;;




}










