#include <stdlib.h>
#include "FreeRTOS.h"
#include "semphr.h"
#include "uart.h"
#include "dualtask.h"
#include "support.h"
#include "tmu.h"
#include "spr_defs.h"

int dtExceptionHelp[2]={0};

int dtTaskCount[2] = {0};
int dtExceptionCount[2] = {0};
int dtForLoop[2] = {0};
int dtCompletedJob[2]={0};
int dtFailed[2]={0};

void dualtask_main()
{
  	int one = 1, two=2;
  	xTaskCreateTMU( dualtask_func, ( signed char * ) "dualtask1", configMINIMAL_STACK_SIZE, (void *) one, dualtask_PRIORITY, NULL, &dualtask1TMU);
	xTaskCreateTMU( dualtask_func, ( signed char * ) "dualtask2", configMINIMAL_STACK_SIZE, (void *) two, dualtask_PRIORITY, NULL, &dualtask2TMU);
}

xTMUStruct dualtask1TMU =
{
	dualtask_exception,
	compare,			// Compare
	NULL
};

xTMUStruct dualtask2TMU =
{
	dualtask_exception,
	compare,	// Compare
	NULL
};

void dualtask_func(void * param)
{
	int taskN = (int *) param;
	int failure= taskN*3;
	int i = 0;
	param=param;
	while(1)
	{
		tmu_restart();
		dtExceptionHelp[taskN-1]= 0;
		dtTaskCount[taskN-1]++;
		failure++;
		if (failure == rate)
		{
			failure = 0;
			for(i = 0; i < 50; i++)
			{
				if (dtExceptionHelp[taskN-1]) break;
				dtForLoop[taskN-1]++;
			}
		}
		if (dtExceptionHelp[taskN-1] == 0)
		{
			dtCompletedJob[taskN-1]++;
		}
	}
}


void dualtask_exception(void * param)
{
	int taskN = (int* ) param;
	dtExceptionHelp[taskN-1] = 1;
	dtExceptionCount[taskN-1]++;
//	report(0xEEEE0000 | taskN);
}

void dtPrint_stats()
{
	//uart_print_str("Stopping FreeRTOS\n\0");
	//uart_print_str("---Stat---\n\0");
	//uart_print_str("Ticks: ");
	//uart_print_int(TickCount);
	//uart_print_str("\n");
	uart_print_int(compare);
	uart_print_str("\t");
	uart_print_int(dtTaskCount[0]);
	uart_print_str("\t");
	uart_print_int(dtExceptionCount[0]);
	uart_print_str("\t");
	uart_print_int(dtCompletedJob[0]);
	uart_print_str("\t");
	uart_print_int(dtForLoop[1]);
	uart_print_str("\t");
	uart_print_int(dtTaskCount[1]);
	uart_print_str("\t");
	uart_print_int(dtExceptionCount[1]);
	uart_print_str("\t");
	uart_print_int(dtCompletedJob[1]);
	uart_print_str("\t");
	uart_print_int(dtForLoop[1]);
	uart_print_str("\n\0");
	//uart_print_int(dtFailed[0]);
	//uart_print_str("\t");
	//uart_print_int(dtFailed[1]);
	//uart_print_str("\n");
}

