#include <stdlib.h>
#include "FreeRTOS.h"
#include "semphr.h"
#include "uart.h"
#include "support.h"
#include "tmu.h"
#include "spr_defs.h"
#include "freertostest.h"

int ftExceptionHelp[2]={0};

int ftTaskCount[2] = {0};
int ftExceptionCount[2] = {0};
int ftForLoop[2] = {0};
int ftCompletedJob[2]={0};
int ftFailed[2]={0};
int TasksRemaining = 0;

typedef unsigned long long ullong;
typedef unsigned long ulong;
void ftMain()
{
  	int one = 1, two=2;
  	xTaskCreateTMU(ftFunc, ( signed char * ) "task1", configMINIMAL_STACK_SIZE, (void *) one, ftPRIORITY, NULL, &ft1TMU);
  	TasksRemaining++;
  	xTaskCreateTMU( ftFunc, ( signed char * ) "task2", configMINIMAL_STACK_SIZE, (void *) two, ftPRIORITY, NULL, &ft2TMU);
	TasksRemaining++;
}

xTMUStruct ft1TMU =
{
	ftException,
	1000000,			// Compare
	NULL
};

xTMUStruct ft2TMU =
{
	ftException,
	2000000,	// Compare
	NULL
};
void forloop()
{
	int i = 0;
	for (i = 0; i< 10000; i++ )
	{
		;;
	}
}

void ftFunc(void * param)
{
	int taskN = (int *) param;
	ullong count = 0;
	int i = 0;
	while(1)
	{
//		report(tmu_get_count());
		count = tmu_get_count();
		vPortDisableInterrupts();
			ftExceptionHelp[taskN-1]= 0;
			uart_print_str("Start \tTask ");
			uart_print_int(taskN);
			uart_print_str(", Compare = ");
			uart_print_int(tmu_get_compare());
			uart_print_str(", Count =  ");
			uart_print_int(count);
			uart_print_str("\n\0");
		vPortEnableInterrupts();

			for (i = 0; i< 10000; i++ )
			{
				;;
			}

		vPortDisableInterrupts();
		if (ftExceptionHelp[taskN-1] == 0)
		{
			uart_print_str("End \t\tTask ");
			uart_print_int(taskN);
			uart_print_str(", Compare = ");
			uart_print_int(tmu_get_compare());
			uart_print_str(", Count =  ");
			uart_print_int(tmu_get_count());
			uart_print_str("\n\0");
		}
		vPortEnableInterrupts();
//					report(tmu_get_count());
		portYIELD();


	}
}


void ftException(void * param)
{
	int taskN = (int* ) param;
	uart_print_int(taskN);
	uart_print_str("-exception \n\0");
	ftExceptionCount[taskN-1]++;
	ftExceptionHelp[taskN-1]=1;
	if (ftExceptionCount[taskN-1] >= taskN*2)
	{
		TasksRemaining--;
		vTaskDelete(NULL);
	}

}

void ftIdleHook()
{
	if (0 >= TasksRemaining)
	{
		vTaskEndScheduler();
	}
}

void ftPrint_stats()
{
	uart_print_str("Stopping FreeRTOS\n\0");
	uart_print_str("---Stat---\n\0");
	uart_print_str("Ticks: ");
	uart_print_int(TickCount);
	uart_print_str("\n");
	uart_print_int(ftExceptionCount[0]);
	uart_print_str("\t");
	uart_print_int(ftExceptionCount[1]);
	uart_print_str("\n");
}

