


#include <stdlib.h>
#include "FreeRTOS.h"
#include "overhead.h"
#include "interrupts.h"
#include "task.h"
#include "support.h"
#include "intgen.h"
#include "uart.h"



unsigned int ohTaskCount = 0;
unsigned int ohExceptionCount = 0;



extern void report_status(char*, int);

#if configUSE_TMU==1	
xTMUStruct ohTMU1 =
{
	ohException,
	0xfffffffffffffff,//ohTASK_LIMIT_1,			// Compare
	NULL,
	NULL
};

#endif
void overhead_main()
{
	vTaskEnterCritical();
	report_status("Setting up tasks", 0);
	int_init();
	int one = 1;
	int zero = 0;
	
#if configUSE_TMU		
	tmu_disable_count_exception();
	tmu_disable_exception();
	xTaskCreateTMU( ohTaskFunction, "Task1", ohSTACK_DEPTH, (void *)one, ohPRIORITY, NULL, &ohTMU1 );
#else
	xTaskCreate( ohTaskFunction, "Task1", ohSTACK_DEPTH, (void *)one, ohPRIORITY, NULL );
#endif
	vTaskExitCritical();
}


void ohTaskFunction(void * param)
{
	int taskN = (int *) param;
	while (1)
	{
		ohTaskCount++;
	}
}


void ohException(void * param)
{
	int taskN = (int *) param;
	//report_status("TMU exception ", taskN);
	ohExceptionCount++;
	//report(0xEEEE0000 | taskN);
}

void ohPrint_stats() {
	
	uart_print_str("Task 1:\n\0 ");
	uart_print_str("\tRounds: ");
	uart_print_int(ohTaskCount);
	uart_print_str("\n\0");
	/*
	uart_print_str("\tExceptions: ");
	uart_print_int(ohExceptionCount[0]);
	uart_print_str("\n\0");
	
	uart_print_str("Task 2:\n\0 ");
	uart_print_str("\tRounds: ");
	uart_print_int(ohTaskCount[1]);
	uart_print_str("\n\0");
	uart_print_str("\tExceptions: ");
	uart_print_int(ohExceptionCount[1]);
	uart_print_str("\n\0");
	
	uart_print_str("Task 3:\n\0 ");
	uart_print_str("\tRounds: ");
	uart_print_int(ohTaskCount[2]);
	uart_print_str("\n\0");
	uart_print_str("\tExceptions: ");
	uart_print_int(ohExceptionCount[2]);
	uart_print_str("\n\0");
	uart_print_str("\n\0");
	uart_print_str("Interrupt 0: ");
	uart_print_int(ohInterruptCount[0]);
	uart_print_str("\n\0");
	
	uart_print_str("Interrupt 1: ");
	uart_print_int(ohInterruptCount[1]);
	uart_print_str("\n\0");
	*/
}




